%% ``The contents of this file are subject to the Erlang Public License,
%% Version 1.1, (the "License"); you may not use this file except in
%% compliance with the License. You should have received a copy of the
%% Erlang Public License along with this software. If not, it can be
%% retrieved via the world wide web at http://www.erlang.org/.
%% 
%% Software distributed under the License is distributed on an "AS IS"
%% basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
%% the License for the specific language governing rights and limitations
%% under the License.
%% 
%% The Initial Developer of the Original Code is Ericsson Utvecklings AB.
%% Portions created by Ericsson are Copyright 1999, Ericsson Utvecklings
%% AB. All Rights Reserved.''
%% 
%%     $Id$
%%
-module(erl.system.debug).

%% NOTE: The low-level debugging support is EXPERIMENTAL!

-export([size/1,df/1,df/2,df/3]).

%% The following are built-in functions belonging to this module:
%%
%%	breakpoint/2		*experimental*
%%	disassemble/1		*experimental*
%%	display/1
%%	display_nl/0
%%	display_string/1
%%	flat_size/1		*experimental*
%%	make_fun/1
%%	process_display/2
%%	resume_process/1
%%	same/2			*experimental*
%%	seq_trace/2
%%	seq_trace_info/1
%%	seq_trace_print/1
%%	seq_trace_print/2
%%	suspend_process/1
%%	trace/3
%%	trace_info/2
%%	trace_pattern/2
%%	trace_pattern/3

size(Term) ->
    erts_debug:size(Term).

df(Mod) ->
    erts_debug:df(Mod).

df(Mod, Func) ->
    erts_debug:df(Mod, Func).

df(Mod, Func, Arity) ->
    erts_debug:df(Mod, Func, Arity).
