%%%----------------------------------------------------------------------
%%% File    : hipe_icode_ssa_liveness.erl
%%% Author  : Tobias Lindahl <tobias.lindahl@it.uu.se>
%%%           
%%%   
%%% Purpose : This file contains the function to perform the liveness analysis
%%%           on ssa.
%%% Created : 2003-09-05
%%%----------------------------------------------------------------------
-module(hipe_icode_ssa_liveness).
-include("../flow/ssa_liveness.inc").

%% Interface to CFG and icode.
%%

cfg_bb(CFG, L) ->
  hipe_icode_cfg:bb(CFG, L).


cfg_fun(CFG)->
  hipe_icode_cfg:function(CFG).

cfg_postorder(CFG) ->
  hipe_icode_cfg:postorder(CFG).


cfg_succ_map(CFG) ->
  hipe_icode_cfg:succ_map(CFG).


cfg_succ(CFG, L) ->
  hipe_icode_cfg:succ(CFG, L).


uses(Instr) ->
  hipe_icode:uses(Instr).


defines(Instr) ->
  hipe_icode:defines(Instr).


is_phi(Instr) ->
  hipe_icode:is_phi(Instr).


phi_arglist(Instr) ->
  hipe_icode:phi_arglist(Instr).
